/*
 * IBM Confidential 
 * OCO Source Materials 
 * 5724-U98, 5655-V48, 5724-U50, 5655-V46  
 * The source code for this program is not published or other- 
 * wise divested of its trade secrets, irrespective of what has 
 * been deposited with the U. S. Copyright Office.
 */
header {
    package com.ibm.nex.odpp.util;
}


{ @SuppressWarnings("all") }
class GrammarParser extends Parser;

options {
    buildAST = true;
    k = 5;
}

grammar
    : (nameValuePair (COMMA nameValuePair)*)
    ;
    
list
    : (LEFTBRACKET (value (COMMA value)*)? RIGHTBRACKET)
    ;
    
map
    : (LEFTCURLY (nameValuePair (COMMA nameValuePair)*)? RIGHTCURLY)
    ;
    
nameValuePair
    : (name EQUALS value)
    ;
    
name
    : NAME
    ;

value
    :   (NAME | NUMBER | list | map| AGE | TRIM | ASTERISK | COPY)
    ;

{ @SuppressWarnings("all") }
class GrammarLexer extends Lexer;

options {
    k = 5;
}

NAME
    : ((ALPHA ) ( ALPHA | DIGIT | UNDERSCORE | MINUS )*)
    ;
    
NUMBER
    : ((PLUS | MINUS)? (DIGIT)+ (DOT (DIGIT)+)?)
    ;
    
AGE 
    :(PERCENTAGE)(ALPHA | DIGIT | UNDERSCORE | MINUS | PERCENTAGE | SLASH | BACKSLASH | SPACE | COLON | DOT)*
    ;

TRIM 
    :(SINGLEQUOTE)(.)*(SINGLEQUOTE)
    ;

COPY
     :('(')(.)*(')')
     ;

COMMA
    : ','
    ;

DOT
    : '.'
    ;
    
EQUALS
    : '='
    ;

LEFTBRACKET
    : '['
    ;
    
LEFTCURLY
    : '{'
    ;
    
RIGHTBRACKET
    : ']'
    ;
    
RIGHTCURLY
    : '}'
    ;
    
UNDERSCORE
    : '_'
    ;
    
ASTERISK
	: '*'
	;    
    
protected    
PERCENTAGE
    : '%'
    ;

protected    
COLON
    : ':'
    ;

protected    
SPACE
    : ' '
    ;
    
protected        
BACKSLASH
    : '\\'
    ;
protected    
SLASH
    : '/'
    ;    
    
protected
ALPHA
    : ('A'..'Z' | 'a'..'z')
    ;
    
protected
DIGIT
    : ('0'..'9')
    ;
    
protected
MINUS
    : '-'
    ;
    
protected
PLUS
    : '+'
    ;

protected
SINGLEQUOTE
    : '\''
    ;
    
protected
WS
    : (' ' | '\t') {$setType(Token.SKIP);}
    ;
